{TMT Pascal compilee
 name: BMFED - BitMap Font EDitor
 author: crs/broncs
}
uses dpmi;
{$DEFINE useGFX}
{$DEFINE usershutdown}
{$DEFINE bmfchange}
{$DEFINE loadbmfwithpal}
{$I SYST.INC}
{$I GFX.INC}
{$I STREAM.INC}
{$I BUF2D.INC}
{$I BMCHAR.INC}
{$I BMFONT.INC}
{$I OPENGFX.INC}
{$I GFXEDIT.INC}
{$I EVENTS.INC}
{$I FONT8.INC}
const
  WINX      =8;
  WINY      =20;
  WINW      =255;
  WINH:dword=170;
  PALDOT    =3;
  CHARBELTY =20;
  fontpals:array[0..3] of string[32]=('','','','');
  fpBLUE    =0;
  fpGREEN   =1;
  fpRED     =2;
  fpSYSTEM  =0;
  fpNORMAL  =1;
  fpMAIN    =3;
  zoom:byte =1;
  selected:array[byte] of boolean=(false,...);
  TGAHDR:array[0..11] of byte=($00,$01,$01,$00,$00,$00,$01,$18,$00,$00,$00,$00);
  BACKUP_LIMIT=240;

var
  ed:TGFXEdit;
  tb,tc,undo:TBMChar;
  color:byte:=31;
  c:char:='A';
  cbak:char;
  bmf:TBMFont;
  filename:string;
  str:TFileStream;
  i,j,k,l,m,mx,my:longint;
  moving:boolean:=false;
  backup:dword;
  inside:boolean;
  e:TEvent;
  selectedStart:byte:=0;

procedure UserShutdown;
var i:integer;
begin
  {$IFDEF usershutdown}
  scr.done;
  ed.done;
  tc.done;
  tb.done;
  undo.done;
  {$ENDIF}
end;  {UserShutdown}

procedure grayscalepal(total:dword);
var i:longint;
begin
  for i:=0 to total do
    setRGB(i,63*i div total,63*i div total,63*i div total);
end;  {grayscalepal}

procedure fw(x,y:TCoordinate;s:string;color,f:byte);
var i,j,k:longint;
begin
  if f and $80<>0 then scr.quad(x,y,length(s) shl either(f=0,3,2),7,0);
  f:=f and 1;
  for k:=1 to length(s) do
    for j:=0 to 7 do
      for i:=0 to either(f=0,7,3) do
        if font8[f][ord(s[k]) shl 3+j] and ($80 shr i)<>0 then scr.setpoint(x+pred(k) shl (2+byte(f=0))+i,y+j,color);
end;  {fw}

procedure changePar(mx,n:longint);
begin
  with bmf.tablo[c] do
  if n<>65536 then begin
    case (mx-48) div 28 of
    0: relx:=bounded(relx+n,-128,127);
    1: rely:=bounded(rely+n,-128,127);
    2: resize(width+n,height);
    3: resize(width,height+n);
    4: shift:=bounded(shift+n,0,255);
    5: bmf.addspace:=bounded(bmf.addspace+n,0,255);
    6: bmf.sizeover:=bounded(bmf.sizeover+n,-128,127);
    7: bmf.sizeunder:=bounded(bmf.sizeunder+n,-128,127);
    8: bmf.lineheight:=bounded(bmf.lineheight+n,1,255);
    end;
    if mx in [131..135] then resize(width+n,height+n);
  end else
    case (mx-48) div 28 of
    0: relx:=bmf.tablo[cbak].relx;
    1: rely:=bmf.tablo[cbak].rely;
    2: resize(bmf.tablo[cbak].w,height);
    3: resize(width,bmf.tablo[cbak].h);
    4: shift:=bmf.tablo[cbak].shift;
    end;
end;  {changepar}

procedure BMFont_save_palette(var f:TStream);
var i:longint;
begin
  for i:=0 to $2FF do pal[i]:=pal[i] and 63;
  color:=bmf.colorsUsed shr 16;
  f.write(color,1);
  for i:=1 to color do
    f.write(pal[i*3],3);
end;  {BMFont_save_palette}

procedure xorcursor(mx,my:longint);
var i,j:longint;
begin
  for j:=0 to 10 do
    for i:=0 to 7 do
      if ((j<=7) and (i<=j)) or ((j>7) and (i<11-j)) then
        scr.xorpoint(mx+i,my+j,$3F);
end;  {xorcursor}

procedure showchar(c:char);
var i,j:integer;
begin
  with bmf.tablo[c] do
  if d<>nil then
    for j:=0 to pred(h) do
      for i:=0 to pred(w) do
        scr.quad(WINX+i*zoom,WINY+j*zoom,zoom,zoom,getpoint(i,j));
end;

procedure loadtga(var str:TFileStream;filename:string11);
var
  i,j,y1:integer;
  cw,ch:word;
  c:char;
  buf:pointer;
begin
  str.init(filename);
  for i:=0 to 11 do begin
    str.read(c,1);
    if ord(c)<>TGAHDR[i] then begin
       str.done;
       exit;
    end;
  end;
  bmf.init0;
  str.read(cw,2);
  str.read(ch,2);
  str.read(i,2);
  cw:=cw shr 4;
  ch:=ch shr 4;
  for i:=0 to 255 do begin
    str.read(j,3);
    pal[i*3]:=byte(j shr 16) shr 2;
    pal[i*3+1]:=byte(j shr 8) shr 2;
    pal[i*3+2]:=byte(j) shr 2;
    if i<240 then setRGB(i,pal[i*3],pal[i*3+1],pal[i*3+2]);
    bmf.tablo[chr(i)].init(cw,ch);
  end;
  fw(8,8,'cw='+pad0(cw,3)+' ch='+pad0(ch,3)+' pos='+pad0(str.SI,4),249,$81);flip;
  getmem(buf,cw);
  for j:=0 to 15 do
    for y1:=pred(ch) downto 0 do begin
      fw(8,16,pad0(j*ch+y1,4)+' ',249,$81);flip;
      for i:=0 to 15 do begin
        str.read(buf^,cw);
        move(buf^,bmf.tablo[chr((15-j) shl 4+i)].atLine(y1)^,cw);
      end;
    end;
  freemem(buf,cw);
  str.done;
end;

procedure savetga(var str:TFileStream;filename:string11);
var
  x1,x2,y1,y2,i,j,cw,ch:longint;
  c:char;
  buf:pointer;
begin
  x1:=0; y1:=0; x2:=0; y2:=0;
  for c:=#0 to #255 do with bmf.tablo[c] do if (w or h<>0) then begin
    if relx<x1 then x1:=relx;
    if relx+w>x2 then x2:=relx+w;
    if rely<y1 then y1:=rely;
    if rely+h>y2 then y2:=rely+h;
  end;
  cw:=x2-x1;
  ch:=y2-y1;
  str.OpenOrCreate(filename);
  str.truncate;
  fw(8,8,'x1='+pad0(x1,3)+' y1='+pad0(y1,3)+' x2='+pad0(x2,3)+' y2='+pad0(y2,3),249,$81);flip;
  str.write(TGAHDR,sizeof(TGAHDR));
  i:=(cw shl 4) or ch shl 20;
  str.write(i,4);
  i:=8;
  str.write(i,2);
  for i:=0 to 255 do begin
    j:=(pal[i*3+2] shl 2+3) or (pal[i*3+1] shl 2+3) shl 8 or (pal[i*3] shl 2+3) shl 16;
    str.write(j,3);
  end;
  getmem(buf,cw*16);
  for j:=pred(ch*16) downto 0 do begin
    fw(8,16,'j='+pad0(j,4)+' ',249,$81);
    flip;
    fillchar(buf^,cw*16,0);
    for i:=0 to 15 do with bmf.tablo[chr(j div ch shl 4 or i)] do
      if isin(j mod ch+y1,rely,rely+h-1) and not empty then move(atline(j mod ch+y1-rely)^,ptr(ofs(buf^)+i*cw+relx-x1)^,w);
    str.write(buf^,cw*16);
  end;
  freemem(buf,cw*16);
  str.done;
end;

procedure cz_macro;
const
  CZMAX=44;
  ca:array[0..CZMAX-1] of char=
    (#$88,#$A8,#$87,#$A9,#$91,#$98,#$A0,#$A1,#$82,#$A3,#$96,#$9F,#$A4,#$83,#$A2,#$84,#$8C,#$8D,#$93,#$AA,#$81,#$94,
     #$89,#$9B,#$80,#$9E,#$92,#$9D,#$8F,#$8B,#$90,#$97,#$A6,#$86,#$A5,#$85,#$95,#$8E,#$9C,#$8A,#$A7,#$AB,#$9A,#$99);
  cb:array[0..CZMAX-1] of char=
    ('e','s','c','r','z','y','a','i','e','u','u','t','n','d','o','a','l','l','o','r','u','o',
     'E','S','C','R','Z','Y','A','I','E','U','U','T','N','D','O','A','L','L','O','R','U','O');
  cc:array[0..CZMAX shr 1-1] of byte=
    ( 2 , 2 , 2 , 2 , 2 , 1 , 1 , 1 , 1 , 1 , 3 , 5 , 2 , 5 , 1 , 4 , 2 , 5 , 6 , 6 , 4 , 4);
  cp:array[0..6] of byte=(0,25,30,34,20,8,28);
    {1=carka, 2=hacek, 3=krouzek, 4=prehlaska, 5=apostrof, 6=striska}
var
  i,t:integer;
  clone:array[0..CZMAX-1] of TBmChar;
begin
  for i:=0 to CZMAX-1 do begin
    clone[i].init0;
    clone[i].copyToMe(@bmf.tablo[cb[i]]);
  end;
  for i:=0 to CZMAX-1 do with bmf.tablo[ca[i]] do begin
    copyToMe(@clone[i]);
    t:=clone[i].h*cp[cc[i]] shr 7;
    resize(w,h+t);
    shiftV(t);
    dec(rely,t);
  end;
end;

procedure cz_macro2; //transforms diacritics chars from Latin-2 to windows-1250
const
  CZMAX=38;
  iso:string[CZMAX]=#$EC#$9A#$E8#$F8#$9E#$FD#$E1#$ED#$E9#$F3#$FA#$F9#$EF#$9D#$F2+#$CC#$8A#$C8#$D8#$8E#$DD#$C1#$CD#$C9#$D3#$DA#$D9#$CF#$8D#$D2#$E4#$EB#$F6#$FC#$E5#$C5#$F4#$D4;
  dos:string[CZMAX]=#$88#$A8#$87#$A9#$91#$98#$A0#$A1#$82#$A2#$A3#$96#$83#$9F#$A4+#$89#$9B#$80#$9E#$92#$9D#$8F#$8B#$90#$95#$97#$A6#$85#$86#$A5#$C4#$DB#$D6#$DC#$8B#$8C#$93#$A7;
var
  i:integer;
  clone:array[1..CZMAX] of TBmChar;
begin
  for i:=1 to CZMAX do begin
    clone[i].init0;
    clone[i].copyToMe(@bmf.tablo[dos[i]]);
    bmf.tablo[dos[i]].free;
  end;
  for i:=1 to CZMAX do
    bmf.tablo[iso[i]].copyToMe(@clone[i]);
end;

procedure xchgPalette(col1, col2:byte);
begin
  xchg(pal[col1*3],pal[col2*3],3);
  setRGB(col1,pal[col1*3],pal[col1*3+1],pal[col1*3+2]);
  setRGB(col2,pal[col2*3],pal[col2*3+1],pal[col2*3+2]);
end;

procedure paletteByLuminance();
var
  i,j,minIndex:byte;
  luminance:array[0..255] of real;
begin
  for i:=1 to pred(bmf.colorsUsed) do
    luminance[i]:=pal[i*3]*0.2126 + pal[i*3+1]*0.7152 + pal[i*3+2]*0.0722;
  for i:=1 to pred(bmf.colorsUsed) do begin
    luminance[0]:=1e6;
    for j:=i to pred(bmf.colorsUsed) do 
      if luminance[j]<luminance[0] then begin
        luminance[0]:=luminance[j];
        minIndex:=j;
      end;
    if i<>minIndex then begin
      for j:=0 to 255 do
        bmf.tablo[chr(j)].replacePoint(i,minIndex,true);
      xchgPalette(i,minIndex);
      xchg(luminance[i],luminance[minIndex],sizeof(real));
    end;
  end;
end;

procedure paletteMinimize();
var
  i,x,y:integer;
  used:array[0..255] of boolean;
begin
  fillchar(used,sizeof(used),0);
  for i:=0 to 255 do
    with bmf.tablo[chr(i)] do
    for y:=0 to pred(h) do
      for x:=0 to pred(w) do
        used[getPoint(x,y)]:=true;
  x:=256;
  for i:=1 to 254 do begin
    if used[i] then continue;
    for x:=pred(x) downto i do
      if used[x] then begin
        for y:=0 to 255 do
          bmf.tablo[chr(y)].replacePoint(i,x,true);
        xchgPalette(i,x);
        break;
      end;
    if x=i then break;
  end;
end;

procedure doWithChar(what:string11);
var i,j,temp:longint;
begin
  with bmf.tablo[c] do
  if length(what)=1 then
    case what[1] of
    #38: cycleH(-1); //alt+l
    #19: cycleH(1);  //alt+r
    #22: cycleV(-1); //alt+u
    #32: cycleV(1);  //alt+d
    #35: if mem[ROM_KEYFLAGS] and (kfANYSHIFT or kfCAPSLOCK)=0 then flipH else softenH; //alt+h
    #47: if mem[ROM_KEYFLAGS] and (kfANYSHIFT or kfCAPSLOCK)=0 then flipV else softenV; //alt+v
    #16: begin cycleV(-1); resize(w,h-1); end; //alt+q - cut from top
    #20: turnRight; //alt+t - turn 90 degrees
    #30: resize(w,h-1); //alt+a - cut from bottom
    #31: resize(w-1,h); //alt+s - cut from right
    #49: minimize; //alt+n
    'S': begin free; if mem[ROM_KEYFLAGS] and kfANYSHIFT=0 then init0; end; //del
    's': shift:=bounded(shift-1,-128,127); //ctrl+left
    't': shift:=bounded(shift+1,-128,127); //ctrl+right
    #127:if not empty then fillchar(d^,w*h,0); //ctrl+bksp - fill with black
    #128:replacePoint(color,(my-WINY) div PALDOT,e.keyflags and kfANYSHIFT<>0); //x, X
    #21: flood((mx-WINX) div zoom,(my-WINY) div zoom,color); //alt+y
    #23: for j:=0 to pred(h) do //???
           for i:=0 to pred(w) do
             setpoint(i,j,color-getpoint(i,j));
    #25: if mx>=WINX then begin //alt+p
           if not empty then shift:=w+relx
         end else
           if color>=2 then grayscalepal(color);
    '0': if not empty then //alt+b - thicken from the right
           for j:=pred(h) downto 0 do
             for i:=pred(w) downto 0 do
               if (getPoint(i,j)=0) and (getPoint(i-1,j)<>0) then
                 setPoint(i,j,getPoint(i-1,j));
    '"': if not empty then //alt+g
           for j:=pred(h) downto 0 do
             for i:=pred(w) downto 0 do
               if getPoint(i,j)=0 then begin
                 if (getPoint(i,j-1)=0) or (getPoint(i-1,j)=0) then addPoint(i,j,1);
                 if (getPoint(i,j+1)=0) or (getPoint(i+1,j)=0) then addPoint(i,j,-1);
               end;
    end
  else if what='21' then changePar(mx,10)
  else if what='22' then inc(rely)
  else if what='23' then resize(w,h+1)
  else if what='24' then begin cycleV(-1); resize(w,h-1); if not empty then inc(rely); end
  else if what='31' then changePar(mx,65536)
  else if what='41' then changePar(mx,-1)
  else if what='42' then dec(relx)
  else if what='43' then resize(w-1,h)
  else if what='44' then begin cycleH(-1); resize(w-1,h); end
  else if what='45' then begin
    with bmf.tablo[c] do begin
      resize(succ(w),h);
      inc(shift);
      for j:=pred(h) downto 0 do //doesn't solve relY
        setPoint(pred(w),j,bmf.tablo[succ(c)].getPoint(0,j));
    end;
    with bmf.tablo[succ(c)] do begin
      cycleH(-1);
      resize(pred(w),h);
      shift:=either(shift=0,0,pred(shift));
    end;
  end
  else if what='5-' then setPoint((mx-WINX) div zoom,(my-WINY) div zoom,Max(getPoint((mx-WINX) div zoom,(my-WINY) div zoom)-1,0))
  else if what='5+' then setPoint((mx-WINX) div zoom,(my-WINY) div zoom,getPoint((mx-WINX) div zoom,(my-WINY) div zoom)+1)
  else if what='61' then changePar(mx,1)
  else if what='62' then inc(relx)
  else if what='63' then resize(w+1,h)
  else if what='65' then begin {ctrl-shift-]}
    with bmf.tablo[succ(c)] do begin
      resize(succ(w),h);
      inc(shift);
      cycleH(1);
      i:=pred(bmf.tablo[c].w);
      for j:=pred(h) downto 0 do //doesn't solve relY
        setPoint(0,j,bmf.tablo[c].getPoint(i,j));
    end;
    with bmf.tablo[c] do begin
      resize(pred(w),h);
      shift:=either(shift=0,0,pred(shift));
    end;
  end
  else if what='81' then changePar(mx,-10)
  else if what='82' then dec(rely)
  else if what='83' then resize(w,h-1)
  else if (what='f*') and (w*h<>0) then begin
    resize(w+2,h+2); shiftH(1); shiftV(1);
    for j:=0 to h-1 do
      for i:=0 to w-1 do
        if ((getpoint(i-1,j)<>0) or (getpoint(i+1,j)<>0) or (getpoint(i,j-1)<>0) or (getpoint(i,j+1)<>0))
          and (getpoint(i,j)=0) then
          setpoint(i,j,color);
  end else if what='fL' then begin
    for j:=0 to h-1 do
      for i:=0 to w-1 do
        if getpoint(i,j)<>0 then setpoint(i,j,color);
  end else if what='5*' then
    for j:=0 to h-1 do
      for i:=0 to w-1 do begin
        setpoint(i,j,getpoint(i,j)*color div 16)
      end  
  else if what='5x' then // fill pattern in tablo[#0]
    for j:=0 to pred(h) do
      for i:=0 to pred(w) do
        if getPoint(i,j)=color then begin
          temp:=bmf.tablo[#0].getPoint(i-relx,j-rely);
          if temp=OUT_OF_BUF2D then
            setPoint(i,j,temp);
        end else
  else if (what='O/') and not empty then begin // border
    resize(w+2,h+2);
    shiftH(1); shiftV(1);
    undo.copyToMe(@bmf.tablo[c]);
    for j:=0 to pred(h) do
      for i:=0 to pred(w) do
        if (undo.getpoint(i,j)=0) and ((undo.getpoint(i-1,j)<>0) or (undo.getpoint(i,j-1)<>0) or (undo.getpoint(i+1,j)<>0) or (undo.getpoint(i,j+1)<>0)) then
          setpoint(i,j,color);
    undo.shiftH(-1); undo.shiftV(-1);
    undo.resize(w-2,h-2);
  end else if (what='w50') and not empty then begin // scale x to 50%
    undo.copyToMe(@bmf.tablo[c]);
    for j:=0 to pred(h) do
      for i:=0 to pred(w div 2) do
        setpoint(i,j,getpoint(i*2,j));
    resize(w div 2,h);
  end else if (what='w200') and not empty then begin // scale x to 200%    
    undo.copyToMe(@bmf.tablo[c]);
    resize(w*2,h);
    for j:=0 to pred(h) do
      for i:=pred(w) downto 0 do begin
        setpoint(i*2,j,getpoint(i,j));
        setpoint(i*2+1,j,getpoint(i,j));
      end
  end else if (what='h50') and not empty then begin // scale y to 50%
    undo.copyToMe(@bmf.tablo[c]);
    for j:=0 to pred(h div 2) do
      move(atLine(j*2)^,atLine(j)^,w);
    resize(w,h div 2);
  end else if (what='h200') and not empty then begin // scale y to 200%
    undo.copyToMe(@bmf.tablo[c]);
    resize(w,h*2);
    for j:=pred(h) downto 0 do begin
      move(atLine(j)^,atLine(j*2)^,w);
      move(atLine(j)^,atLine(j*2+1)^,w);
    end
  end else if (what='sh1') or (what='sh2') or (what='sh3') or (what='sh4') or (what='sh6') or (what='sh7') or (what='sh8') or (what='sh9') then //cast shadow 1px certain direction from bitmap
    if not empty then begin
      temp:=either((what='sh1') or (what='sh2') or (what='sh3'),$0200,either((what='sh4') or (what='sh6'),$0100,0));
      temp:=temp or either((what='sh3') or (what='sh6') or (what='sh9'),2,either((what='sh2') or (what='sh8'),1,0));
      for j:=pred(h) downto 0 do
        for i:=pred(w) downto 0 do
          if (getPoint(i,j)=0) and (getPoint(i+lo(temp)-1,j+hi(temp)-1)<>0) then
            setPoint(i,j,color);
    end  
end;  {doWithChar}

procedure doWithChars(what:string11);
var any:boolean;
begin
  if mem[ROM_KEYFLAGS] and kfSCROLLLOCK=0 then
    doWithChar(what)
  else begin
    cbak:=c;
    if (mx>=188) and ((what='41') or (what='61') or (what='21') or (what='81')) then
      doWithChar(what)
    else begin
      any:=false;
      for c:=#0 to #255 do
        if selected[ord(c)] then begin
          doWithChar(what);
          any:=true;
        end;
      if not any then
        for c:=#0 to #255 do
          doWithChar(what);
    end;
    c:=cbak;
  end;
end;  {doWithChars}

begin
  clearRegs;
  filename:=paramstr(1);
  if fileExists(filename+'.bmf') then filename:=filename+'.bmf';
  scr.init(0,0,0,0);
  bmf.init0; 
  tc.init0; 
  undo.init0; 
  tb.init0; 
  ed.init0;
  if (paramstr(1)='/?') or (paramstr(1)='-?') then begin
    bioswriteln(#13#10'Syntax: bmfed <filename> [[-fn|-cleanup] -savequit|-create]');
    bioswriteln('<filename>  File in a BMF file format. You can omit the file extention.');
    bioswriteln('-fn         Convert file from the FN file format.');
    bioswriteln('-cleanup    Minimize bitmaps and palette.');
    bioswriteln('-savequit   Save the file and quit immediately.');
    bioswriteln('-create     Create the file.');
    bioswriteln('-?          Show this help.');
    die(0);
  end;
  if paramstr(2)<>'-create' then begin
    if not fileExists(filename) then die(errFileNotExists);
    str.init(filename);
    if (paramstr(2)='-savequit') or (paramstr(3)='-savequit') then begin
      if paramstr(2)='-fn' then begin
        bmf.loadAsFN(str);
        filename:=system.copy(filename,1,length(filename)-3)+'.bmf';
      end else bmf.load(str);
      if not str.ok then die(errBMFLoad);
      str.done; str.init(filename);
      if paramstr(2)='-cleanup' then begin
        for i:=0 to 255 do
          bmf.tablo[chr(i)].minimize();
        paletteMinimize();
        paletteByLuminance();
      end;
      if bmf.save(str) then i:=0 else i:=2;
      str.truncate;
      bioswriteln(eitherS(i=0,'ok','NOT ok'));
      str.done; bmf.done;
      die(i);
    end;
  end;
  OpenGFX('320x240x8');
  for i:=0 to 63 do begin
    setRGB(i,i,i,i);
    if i>0 then fontpals[fpMAIN]:=fontpals[fpMAIN]+chr(i);
  end;
  for i:=0 to 4 do begin
    setRGB(240+i,3+i*6,3+i*8,3+i*15); fontpals[fpBLUE]:=fontpals[fpBLUE]+chr(240+i);
    setRGB(245+i,3+i*8,3+i*15,3+i*8); fontpals[fpNORMAL]:=fontpals[fpNORMAL]+chr(245+i);
    setRGB(250+i,3+i*15,3+i*8,3+i*8); fontpals[fpSYSTEM]:=fontpals[fpSYSTEM]+chr(250+i);
  end;
  grayscalepal(32);
  fillpal;
  if paramstr(2)<>'-create' then begin
    if paramstr(2)='-fn' then begin
      bmf.loadAsFN(str);
      filename:=system.copy(lcased(filename),1,length(filename)-3)+'.bmf';
    end else bmf.load(str);
    str.done;
  end else begin
    bmf.tablo['A'].resize(10,10);
    zoom:=4;
  end;
  WINH:=ScrHeight-20;
  scr.init(0,0,ScrWidth,ScrHeight);
  InitMouse; 
  evAutoLimit:=1;
  with ed do begin
    init(0,ScrHeight-50,ScrWidth,50,@bmf,ofs(fontpals[fpMAIN]));
    blcolor:=nearestColor(32,32,63,fontmethod);
    text:=bmf.name;
  end;
  color:=bmf.colorsUsed shr 16; 
  PAD0CHAR:=' ';
  backup:=unix_timestamp();
  repeat
    with bmf.tablo[c] do begin
      if unix_timestamp() - backup > BACKUP_LIMIT then begin
        savetga(str,'backup.tga');
        backup:=unix_timestamp();
      end;
      scr.paint(0);
      if moving then scr.quad(0,ScrHeight-3,256,3,243);
      fw(0,0,'char dec hex   relx   rely  width height  shift addSpc szOver szUndr lineHt',249,1);
      scr.quad(0,WINY-1,PALDOT,32*PALDOT+2,244);
      for i:=0 to 31 do begin
        scr.quad(0,WINY+i*PALDOT,PALDOT,PALDOT,i);
        if color=i then scr.setpoint(0,WINY+i*PALDOT,253);
      end;
      bmf.dest:=@scr;
      bmf.writexy(ed.x,ed.y,ed.text);
      fw(12,7,c+' '
       +pad0(ord(c),3)+'  '
       +system.copy(hex(ord(c)),7,2)+'    '
       +pad0(relx,3)+'    '
       +pad0(rely,3)+'    '
       +pad0(w,3)+'    '
       +pad0(h,3)+'    '
       +pad0(shift,3)+'    '
       +pad0(bmf.addspace,3)+'  '
       +pad0(bmf.sizeover,5)+'  '
       +pad0(bmf.sizeunder,5)+'  '
       +pad0(bmf.lineheight,5),254,1);
      scr.quad(WINX-1,WINY-1,w*zoom+2,h*zoom+2,243);
      showchar(c);
      if e.typ=evMOUSE then begin
        mx:=e.x;
        my:=e.y;
      end;
      for i:=0 to 255 do begin
        if selected[i] or (i=ord(c)) or (bmf.tablo[chr(i)].shift>0) or (bmf.tablo[chr(i)].w>0) then 
          scr.quad(ScrWidth-16*8+i and 15*8,CHARBELTY+i and $F0 shr 1,8,8,either(i=ord(c),253,either(selected[i] or (i=ord(c)),246,241)));
        fw(ScrWidth-16*8+i and 15*8,CHARBELTY+i and $F0 shr 1,char(i),244-byte(selected[i]),0);
      end;
      inside:=contains((mx-WINX) div zoom,(my-WINY) div zoom);
      j:=1;
      if inside then i:=getPoint((mx-WINX) div zoom,(my-WINY) div zoom) else i:=-1;
      if isin(mx,0,PALDOT-1) and isin(my,WINY,WINY+PALDOT*32) then i:=(my-WINY) div PALDOT else j:=0;
      fw(192,14,'['+inttostr(either(inside,(mx-WINX) div zoom,mx))+','+inttostr(either(inside,(my-WINY) div zoom,my))+']='+inttostr(i)+eitherS(j=0,'',' {'+inttostr(pal[i*3])+','+inttostr(pal[i*3+1])+','+inttostr(pal[i*3+2])+'}'),243,1);
      fw(300,0,timestr,243,1);
      fw(300,7,chr(either(mem[ROM_KEYFLAGS] and kfNUMLOCK<>0,ord('N'),32))+chr(either(mem[ROM_KEYFLAGS] and kfCAPSLOCK<>0,ord('C'),32))+chr(either(mem[ROM_KEYFLAGS] and kfSCROLLLOCK<>0,ord('S'),32))+chr(either(mem[ROM_KEYFLAGS] and kfINSERT<>0,ord('I'),32)),244,1);
      if e.typ=evKEYBOARD then fw(300,14,inttostr(ord(e.key))+' '+inttostr(ord(e.keyext)),243,1);
      xorcursor(mx,my);
      flip;
      i:=mem[ROM_KEYFLAGS];
      repeat until GetEvent(e) or (i<>mem[ROM_KEYFLAGS]);
      case e.typ of
      evKEYBOARD:
        case e.key of
        #0:
          case e.keyext of
          'H': if my<=16 then doWithChars('81') else if not moving then dec(c,16) else if mem[ROM_KEYFLAGS] and kfANYSHIFT=0 then doWithChars('82') else doWithChars('83');
          'P': if my<=16 then doWithChars('21') else if not moving then inc(c,16) else if mem[ROM_KEYFLAGS] and kfANYSHIFT=0 then doWithChars('22') else doWithChars('23');
          'K': if my<=16 then doWithChars('41') else if not moving then dec(c) else if mem[ROM_KEYFLAGS] and kfANYSHIFT=0 then doWithChars('42') else doWithChars('43');
          'M': if my<=16 then doWithChars('61') else if not moving then inc(c) else if mem[ROM_KEYFLAGS] and kfANYSHIFT=0 then doWithChars('62') else doWithChars('63');
          's','t',#19,#20,#21,#22,#23,#25,' ','#','/',#16,'&','S','1','0',#30,#31,#34:
            begin
              undo.copyToMe(@bmf.tablo[c]);
              doWithChars(e.keyext);
            end;
          'G': c:=#32; {Home}
          'O': c:=#127; {End}
          '<': {F2}
            begin
              bmf.name:=ed.text;
              fw(120,96,'Saving...',254,1);
              str.openOrCreate(eitherS(e.keyext='<',filename,'out.bmf'));
              bmf.save(str);
              str.truncate;
              fw(120,104,eitherS(str.ok,'Saved.','Error!'),254,1); flip;
              waitflicks(either(str.ok,20,70));
              str.done;
            end;
          '=': {F3}
            begin
              str.init(filename);
              bmf.init0;
              bmf.load(str);
              str.done;
            end;
          'i': {alt-F2}
            repeat
              str.openOrCreate('bmfed.tmp');
              str.truncate;
              for i:=0 to 255 do
                if selected[i] then begin
                  str.write(i,1);
                  fw(120,104,eitherS(str.ok,'Saving char #'+inttostr(i),'Error saving characters!'),254,$81); flip;
                  bmf.tablo[char(i)].save(str);
                end;
              str.truncate;
              str.done;
            until true;
          'j': {alt-F3}
            repeat
              str.init('bmfed.tmp'); i:=0;
              while str.ok do begin
                str.read(i,1);
                fw(120,104,eitherS(str.ok,'Loading char #'+inttostr(i),'Error loading characters!'),254,$81); flip;
                selected[i]:=true;
                with bmf.tablo[chr(i)] do begin
                  free;
                  load(str);
                end;
              end;
              str.done;
            until true;
          '_': savetga(str, eitherS(mem[ROM_KEYFLAGS] and kfANYSHIFT=0, 'font.tga', 'backup.tga')); {ctrl-f2}
          '`': loadtga(str, eitherS(mem[ROM_KEYFLAGS] and kfANYSHIFT=0, 'font.tga', 'backup.tga')); {ctrl-f3}
          '?': {f5}
            begin
              fw(120,50+0*8,'SELECT MACRO',254,$81);
              fw(120,50+1*8,'------------',254,$81);
              fw(120,50+2*8,'1..cz_macro',254,$81);
              fw(120,50+3*8,'2..cz_macro2',254,$81);
              fw(120,50+4*8,'3..discard all behind #',254,$81);
              fw(120,50+5*8,'4..monotype',254,$81);
              fw(120,50+6*8,'7..fill pattern in [#0]',254,$81);
              fw(120,50+7*8,'9..remap 0..9 from #',254,$81);
              fw(120,50+8*8,'0..page #2',254,$81);
              fw(120,50+9*8,'s..cast shadow',254,$81);
              flip;
              case readkey of
              '1': cz_macro;
              '2': cz_macro2;
              '3': with bmf do
                     for i:=ord(c)+1 to 255 do tablo[chr(i)].init0;
              '4': for k:=0 to 255 do with bmf.tablo[char(k)] do
                     if (w or h=0) and (k<>32) then
                       shift:=0
                     else begin
                       relx:=(bmf.tablo[' '].shift-w) div 2;
                       shift:=bmf.tablo[' '].shift;
                     end;
              '7': doWithChars('5x');
              '9': with bmf do 
                   for i:=0 to 9 do 
                     tablo[chr(ord('0')+either(c>'0',i,9-i))].cloneFrom(@tablo[chr(ord(c)+either(c>'0',i,9-i))]);
              '0': begin                                  
                     fw(120,50+0*8,'MACRO, PAGE #2         ',254,$81);
                     fw(120,50+1*8,'------------           ',254,$81);
                     fw(120,50+2*8,'1..palette by luminance',254,$81);
                     fw(120,50+3*8,'2..save palette        ',254,$81);
                     fw(120,50+4*8,'3..load palette        ',254,$81);
                     fw(120,50+5*8,'4..X-scale to 50%      ',254,$81);
                     fw(120,50+6*8,'5..X-scale to 200%     ',254,$81);
                     fw(120,50+7*8,'6..Y-scale to 50%      ',254,$81);
                     fw(120,50+8*8,'7..Y-scale to 200%     ',254,$81);
                     fw(120,50+9*8,'8..copy A..Z to a..z   ',254,$81);
                     fw(120,50+10*8,'9..minimize palette    ',254,$81);
                     flip;
                     case readkey of
                     '1': paletteByLuminance();
                     '2': begin
                            str.openOrCreate('bmfed.col');
                            for i:=0 to 255 do begin
                              j:=pal[i*3+2] shl 18 or pal[i*3+1] shl 10 or pal[i*3] shl 2;
                              str.write(j,3);
                            end;
                            str.done;
                          end;
                     '3': begin
                            str.init('bmfed.col');
                            if str.ok then
                              for i:=0 to pred(max(str.size div 3,64)) do begin
                                str.read(j,3);
                                setRGB(i,byte(j) shl 2,byte(j shr 8) shl 2,byte(j shr 16) shl 2);
                              end;
                            str.done;
                          end;
                     '4': doWithChars('w50');
                     '5': doWithChars('w200');
                     '6': doWithChars('h50');
                     '7': doWithChars('h200');
                     '8': for i:=ord('A') to ord('Z') do
                            bmf.tablo[chr(i+32)].copyToMe(@bmf.tablo[chr(i)]);
                     '9': paletteMinimize();
                     end;
                   end;
              's','S': begin
                     fw(120,50+0*8,'CAST SHADOW            ',254,$81);
                     fw(120,50+1*8,'------------           ',254,$81);
                     fw(120,50+2*8,'1..1px left down       ',254,$81);
                     fw(120,50+3*8,'2..1px down            ',254,$81);
                     fw(120,50+4*8,'3..1px right down      ',254,$81);
                     fw(120,50+5*8,'4..1px left            ',254,$81);
                     fw(120,50+6*8,'6..1px right           ',254,$81);
                     fw(120,50+7*8,'7..1px left up         ',254,$81);
                     fw(120,50+8*8,'8..1px up              ',254,$81);
                     fw(120,50+9*8,'9..1px right up        ',254,$81);
                     fw(120,50+10*8,'0..cancel             ',254,$81);
                     flip;
                     doWithChars('sh'+readkey);
                   end;
              end;
            end;
          'I': if inside then doWithChars('5+') else doWithChars('5^'); {PgUp}
          'Q': if inside then doWithChars('5-') else doWithChars('5v'); {PgDn}
          #132:color:=bounded(color-1,0,31); {Ctrl-PgUp}
          'v': if e.keyflags and kfANYSHIFT=0 then color:=bounded(color+1,0,31) else doWithChars('5*'); {Ctrl-PgDn}
          '!': {alt-f, fill line}
            if inside and (e.keyflags and kfCTRL=0) then begin
              j:=getpoint((mx-WINX) div zoom,(my-WINY) div zoom);
              if e.keyflags and kfSCROLLLOCK=0 then
                for i:=0 to w-1 do
                  if getpoint(i,(my-WINY) div zoom)=j then setpoint(i,(my-WINY) div zoom,color) else
              else
                for k:=0 to 255 do with bmf.tablo[char(k)] do
                  for i:=0 to w-1 do
                    if getpoint(i,(my-WINY) div zoom-rely+bmf.tablo[c].rely)=j then setpoint(i,(my-WINY) div zoom-rely+bmf.tablo[c].rely,color);
            end else begin
              m:=bmf.colorsUsed shr 16; k:=0;
              for c:=#0 to #255 do with bmf.tablo[c] do
                if k<>0 then break else
                  for j:=0 to h-1 do
                    if k<>0 then break else
                      for i:=0 to w-1 do
                        if getPoint(i,j)=m then begin
                          dec(c);
                          placeMouseCursor(WINX+i*zoom,WINY+j*zoom);
                          k:=1;
                          break;
                        end;
            end;
          'R': {Insert}
            begin
              scr.quad(0,ScrHeight-3,256,3,248);
              k:=bounded(tb.x,0,w-tb.w);
              l:=bounded(tb.y,0,h-tb.h);
              undo.copyToMe(@bmf.tablo[c]);
              repeat
                if empty or tb.empty then break;
                bmf.tablo[c].copyToMe(@undo);
                bmf.tablo[c].pasteInMe(k,l,@tb);
                fw(192,14,'PASTE '+inttostr(k)+','+inttostr(l)+'  ',244,$81);
                for j:=0 to pred(h) do
                  for i:=0 to pred(w) do
                    scr.quad(WINX+i*zoom,WINY+j*zoom,zoom,zoom,getpoint(i,j));
                flip;
                repeat until getEvent(e);
                if e.typ=evKEYBOARD then
                  case e.key of
                  #27: begin bmf.tablo[c].copyToMe(@undo); break; end; {esc=cancel}
                  #13: break; {enter=confirm}
                  #0:
                    case e.keyext of
                    'H': l:=bounded(l-1,-tb.h,h);
                    'P': l:=bounded(l+1,-tb.h,h);
                    'K': k:=bounded(k-1,-tb.w,w);
                    'M': k:=bounded(k+1,-tb.w,w);
                    'I': l:=0; {PgUp}
                    'Q': l:=h-tb.h; {PgDn}
                    'G': k:=0; {Home}
                    'O': k:=w-tb.w; {End}
                    'R': tb.method:=either(tb.method=mtTransparent,mtMovsd,mtTransparent); {insert=toggle bagkround}
                    '/': tb.flipV; {alt-v}
                    '#': tb.flipH; {alt-h}
                    #20: tb.turnRight; {alt-t=turn}
                    #23: for j:=0 to tb.h-1 do for i:=0 to tb.w-1 do tb.setpoint(i,j,color-tb.getpoint(i,j));
                    'S': begin bmf.tablo[c].copyToMe(@undo); break; end; {num enter=confirm}
                    end;
                  end;
              until false;
            end;
          'A': selectedStart:=ord(c); {F7}
          'B': {F8}
            for i:=0 to 255 do begin
              if (i>=selectedStart) and (i<=ord(c)) then selected[i]:=true else selected[i]:=false;
            end;
        end;
        #26: bmf.tablo[c].copyToMe(@undo); {ctrl-z}
        #27: {ctrl-[ or escape}
          if e.keyscan=1 then begin
            e.typ:=evMESSAGE;
            e.msgCode:=msgQuit;
          end else
            if mem[ROM_KEYFLAGS] and kfANYSHIFT=0 then
              if mem[ROM_KEYFLAGS] and kfSCROLLLOCK=0 then begin
                for i:=ord(c) to 254 do
                  bmf.tablo[char(i)]:=bmf.tablo[char(succ(i))];
                bmf.tablo[#255].free;
              end else begin
                tc:=bmf.tablo[#255];
                for i:=255 downto 1 do
                  bmf.tablo[char(i)]:=bmf.tablo[char(pred(i))];
                bmf.tablo[#0]:=tc;
                tc.init0;
              end
            else {ctrl-shift-[}
              doWithChars('45');
        #29: {ctrl-]}
          if mem[ROM_KEYFLAGS] and kfANYSHIFT=0 then
            if mem[ROM_KEYFLAGS] and kfSCROLLLOCK=0 then begin
              for i:=pred(ord(c)) downto 0 do
                bmf.tablo[char(succ(i))]:=bmf.tablo[char(i)];
              bmf.tablo[#0].free;
            end else begin
              tc:=bmf.tablo[#0];
              for i:=0 to 254 do
                bmf.tablo[char(i)]:=bmf.tablo[char(succ(i))];
              bmf.tablo[#255]:=tc;
              tc.init0;
            end
          else {ctrl-shift-]}
            doWithChars('65');
        #1: {ctrl-a}
          tb.copyToMe(@bmf.tablo[c]);
        '+': if e.keyscan<>78 then c:='+' else if zoom<16 then inc(zoom);
        '-': if e.keyscan<>74 then c:='-' else if zoom>1 then dec(zoom);
        '?': if inside then color:=getPoint((mx-WINX) div zoom,(my-WINY) div zoom) else c:='?';
        #13: if my<=16 then doWithChars('31') else ed.text:=ed.input(ed.text,255,255);
        ' ':
          if (mx>=ScrWidth-16*8) and isin(my,CHARBELTY,CHARBELTY+16*8-1) then begin
            if e.keyflags and kfANYSHIFT<>0 then begin
              j:=integer(not selected[ord(c)]);
              for i:=0 to 255 do
                selected[i]:=boolean(j);
            end else
              selected[ord(c)]:=not selected[ord(c)];
          end else moving:=not moving;
        #127: {ctrl-backspace}
          if mx>=WINX then begin
            undo.copyToMe(@bmf.tablo[c]);
            doWithChars(#127);
          end;
        #3{ctrl-c},#24{ctrl-x}:
             begin
               tc.copyToMe(@bmf.tablo[c]);
               if e.key=#24 then bmf.tablo[c].free;
             end;
        #22: if e.keyscan<>47 then c:=#22 else begin undo.copyToMe(@bmf.tablo[c]); bmf.tablo[c].copyToMe(@tc); end; {ctrl-v}
        #24: doWithChars('O/'); {alt+o}
        'r': if mx<WINX then setRGB(color,(pal[color*3]+1) and 63,pal[color*3+1],pal[color*3+2]) else c:=e.key;
        'R': if mx<WINX then setRGB(color,(pal[color*3]-1) and 63,pal[color*3+1],pal[color*3+2]) else c:=e.key;
        'g': if mx<WINX then setRGB(color,pal[color*3],(pal[color*3+1]+1) and 63,pal[color*3+2]) else c:=e.key;
        'G': if mx<WINX then setRGB(color,pal[color*3],(pal[color*3+1]-1) and 63,pal[color*3+2]) else c:=e.key;
        'b': if mx<WINX then setRGB(color,pal[color*3],pal[color*3+1],(pal[color*3+2]+1) and 63) else c:=e.key;
        'B': if mx<WINX then setRGB(color,pal[color*3],pal[color*3+1],(pal[color*3+2]-1) and 63) else c:=e.key;
        'a': if mx<WINX then setRGB(color,(pal[color*3]+1) and 63,(pal[color*3+1]+1) and 63,(pal[color*3+2]+1) and 63) else c:=e.key;
        'A': if mx<WINX then setRGB(color,(pal[color*3]-1) and 63,(pal[color*3+1]-1) and 63,(pal[color*3+2]-1) and 63) else c:=e.key;
        'x','X':
             if mx>=WINX then c:=e.key
             else begin
               doWithChars(#128);
               if e.keyflags and kfANYSHIFT<>0 then begin
                 xchgPalette(color, (my-WINY) div PALDOT);
               end;
             end;
        '{': if (mem[ROM_KEYFLAGS] and kfANYSHIFT=kfANYSHIFT) then begin //BOTH shifts+[ - append previous char's last column to the left to the current char
               if bmf.tablo[pred(c)].w > 0 then begin
                 resize(w+1,h);
                 cycleH(1);
                 inc(shift);
                 for j:=0 to pred(bmf.tablo[pred(c)].h) do
                   setPoint(0,(h-bmf.tablo[pred(c)].h)+(rely-bmf.tablo[pred(c)].rely)+j, bmf.tablo[pred(c)].getPoint(pred(bmf.tablo[pred(c)].w),j));
                 with bmf.tablo[pred(c)] do begin resize(w-1,h); shift:=either(shift > 0,shift-1,0); end;
               end  
             end else c:=e.key;
        '}': if (mem[ROM_KEYFLAGS] and kfANYSHIFT=kfANYSHIFT) then begin //BOTH shifts+] - append next char's first column to the right to the current char
               if bmf.tablo[succ(c)].w > 0 then begin
                 resize(w+1,h);
                 inc(shift);
                 for j:=0 to pred(bmf.tablo[succ(c)].h) do
                   setPoint(pred(w),(h-bmf.tablo[succ(c)].h)+(rely-bmf.tablo[succ(c)].rely)+j, bmf.tablo[succ(c)].getPoint(0,j));
                 with bmf.tablo[succ(c)] do begin cycleH(-1); resize(w-1,h); shift:=either(shift > 0,shift-1,0); end;
               end  
             end else c:=e.key;
        else c:=e.key;
        end;
      evMOUSE:
        begin
          if (mx>=ScrWidth-16*8) and isin(my,CHARBELTY,CHARBELTY+16*8-1) then begin {select or mark character}
            k:=(my-CHARBELTY) shr 3 shl 4+(mx-(ScrWidth-16*8)) shr 3;
            if e.buttons and mbLEFT<>0 then c:=char(k)
            else if e.action and evRIGHTPRESSED<>0 then selected[k]:=not selected[k];
          end;
          if isin(mx,0,3) and isin(my,WINY,WINY+32*3-1) then {select color}
            if e.action and evLEFTPRESSED<>0 then color:=(my-WINY) div 3 else else
          if (e.buttons and (mbLEFT or mbRIGHT)<>0) and inside then
            if mem[ROM_KEYFLAGS] and kfANYALT<>0 then begin {draw line}
              k:=(e.x-WINX) div zoom;
              l:=(e.y-WINY) div zoom;
              xorcursor(mx,my);
              repeat
                if e.typ=evMOUSE then begin
                  mx:=bounded((e.x-WINX) div zoom,0,w-1);
                  my:=bounded((e.y-WINY) div zoom,0,h-1);
                  if e.buttons<>0 then m:=e.buttons;
                end;
                undo.copyToMe(@bmf.tablo[c]);
                line(k,l,mx,my,color); showchar(c);
                fw(192,14,'LINE '+inttostr(abs(mx-k)+1)+'x'+inttostr(abs(my-l)+1)+' ',248,$81);
                flip;
                bmf.tablo[c].copyToMe(@undo);
                repeat until GetEvent(e);
                if (e.typ=evMOUSE) and (e.buttons and (mbLEFT or mbRIGHT)=0) then break;
                if (e.typ=evKEYBOARD) and (e.keyscan=1) then break;
              until false;
              mx:=(bounded(e.x,WINX,WINX+width*zoom-1)-WINX) div zoom;
              my:=(bounded(e.y,WINY,WINY+height*zoom-1)-WINY) div zoom;
              undo.copyToMe(@bmf.tablo[c]);
              line(k,l,mx,my,color);
            end else if mem[ROM_KEYFLAGS] and kfANYSHIFT=0 then
              if (e.action and (evMOUSEAUTO or evRIGHTPRESSED)<>0) then
                if mem[ROM_KEYFLAGS] and kfCAPSLOCK<>0 then begin {blur/antialias}
                  mx:=(mx-WINX) div zoom; my:=(my-WINY) div zoom;
                  l:=9; k:=getpoint(mx,my);
                  if contains(mx-1,my-1) then inc(k,getpoint(mx-1,my-1)) else dec(l);
                  if contains(mx-1,my+1) then inc(k,getpoint(mx-1,my+1)) else dec(l);
                  if contains(mx+1,my-1) then inc(k,getpoint(mx+1,my-1)) else dec(l);
                  if contains(mx+1,my+1) then inc(k,getpoint(mx+1,my+1)) else dec(l);
                  if contains(mx,my-1) then inc(k,getpoint(mx,my-1)) else dec(l);
                  if contains(mx,my+1) then inc(k,getpoint(mx,my+1)) else dec(l);
                  if contains(mx-1,my) then inc(k,getpoint(mx-1,my)) else dec(l);
                  if contains(mx+1,my) then inc(k,getpoint(mx+1,my)) else dec(l);
                  setpoint(mx,my,k div l)
                end else setpoint((mx-WINX) div zoom,(my-WINY) div zoom,either(e.buttons and mbRIGHT<>0,0,color)) else
            else if e.buttons and (mbLEFT or mbRIGHT)<>0 then begin
              k:=(e.x-WINX) div zoom;
              l:=(e.y-WINY) div zoom;
              xorcursor(mx,my);
              repeat
                if e.typ=evMOUSE then begin
                  mx:=bounded((e.x-WINX) div zoom,0,w-1);
                  my:=bounded((e.y-WINY) div zoom,0,h-1);
                  if e.buttons<>0 then m:=e.buttons;
                end;
                xorcursor(WINX+mx*zoom,WINY+my*zoom);
                for j:=min(l,my) to max(l,my) do for i:=min(k,mx) to max(k,mx) do scr.xorpoint(WINX+i*zoom,WINY+j*zoom,$1F);
                fw(192,14,'QUAD '+inttostr(abs(mx-k)+1)+'x'+inttostr(abs(my-l)+1)+' ',248,$81);
                flip;
                xorcursor(WINX+mx*zoom,WINY+my*zoom);
                for j:=min(l,my) to max(l,my) do for i:=min(k,mx) to max(k,mx) do scr.xorpoint(WINX+i*zoom,WINY+j*zoom,$1F);
                repeat until GetEvent(e);
                if (e.typ=evMOUSE) and (e.buttons and (mbLEFT or mbRIGHT)=0) then break;
                if (e.typ=evKEYBOARD) and (e.keyscan=1) then break;
              until false;
              mx:=(bounded(e.x,WINX,WINX+width*zoom-1)-WINX) div zoom;
              my:=(bounded(e.y,WINY,WINY+height*zoom-1)-WINY) div zoom;
              if e.typ<>evKEYBOARD then
                if m and (mbLEFT or mbRIGHT)=mbLEFT then begin
                  undo.copyToMe(@bmf.tablo[c]);
                  quad(min(k,mx),min(l,my),abs(mx-k)+1,abs(my-l)+1,color);
                end else if m and (mbLEFT or mbRIGHT)=mbRIGHT then begin
                  tb.free;
                  tb.init(abs(mx-k)+1,abs(my-l)+1);
                  tb.pasteInMe(-min(k,mx),-min(l,my),@bmf.tablo[c]);
                  tb.moveto(min(mx,k),min(my,l));
                end;
            end;
        end;
      end;
    end;
  until MessageCode(e)=msgQuit;
  bmf.done;
  die(errOk);
end.

{TO DO:
* minimize palette
* sort palette by intensity (luma sort)
* draw filled triangle
* slant
* blur (but not for color#0)
* replace color with texture stored in char #0
* '5^' a '5v' - add/sub to/from all pixels
}