{$IFNDEF buf2d}
{$DEFINE buf2d}
{$I RECT.INC}
{$I VRAM.INC}
{$IFDEF fw}
  {$I FONT8.INC}
{$ENDIF}
const
  OUT_OF_BUF2D=0; {see getPoint()}
  FLOODFILLSTACKSIZE=64;
var
  floodfillstack:array[0..FLOODFILLSTACKSIZE-1] of TPosition;
  floodfillSP:longint:=0;
type
  PBuf2d=^TBuf2d;
  TBuf2d=object(TRect)
  private
    d:pointer;
    method:longint;
    Procedure flood2(_x,_y:TCoordinate; c1:byte);
  public
    Constructor init0;
    Constructor init(_x,_y,_w,_h:TCoordinate);
    Procedure clear; virtual;
    Procedure free; virtual;
    Procedure dim;
    Procedure redim;
    Procedure resize(_w,_h:TCoordinate); virtual;
    Procedure paint(color:byte); virtual;
    Function  load(var f:TStream):boolean; virtual;
    Function  save(var f:TStream):boolean; virtual;
    Procedure copyToMe(src:PRect); virtual;
    Function  empty:boolean; virtual;
    Function  at(_x,_y:TCoordinate):pointer; virtual;
    Function  atLine(_y:longint):pointer; virtual;
    Function  contains(_x,_y:TCoordinate):boolean; virtual;
    Function  getPoint(_x,_y:TCoordinate):byte;
    Procedure setPoint(_x,_y:TCoordinate;point:byte);
    Procedure xorPoint(_x,_y:TCoordinate;point:byte);
    Procedure addPoint(_x,_y:TCoordinate;point:byte);
    Procedure paintRow(_x,_y,_w:TCoordinate; c:byte);
    Procedure paintColumn(_x,_y,_h:TCoordinate; c:byte);
    Procedure quad(_x,_y,_w,_h:TCoordinate; c:byte);
    Procedure quad_(_x,_y,_w,_h:TCoordinate; c:byte);
    Procedure border(thickness,c1,c2:byte);
    Procedure line(x0,y0,x1,y1:TCoordinate; c:byte);
    Procedure turnRight; virtual;
    Procedure flipH;
    Procedure flipV;
    Procedure pasteInMe(_x,_y:TCoordinate;host:PBuf2d);
    Procedure pasteMeTo(dest:PBuf2d;_x,_y:TCoordinate);
    Procedure cloneFrom(p:PBuf2d); 
    Procedure cycleH(rel:longint);
    Procedure cycleV(rel:longint);
    Procedure shiftH(rel:longint);
    Procedure shiftV(rel:longint);
    Procedure replacePoint(old,new:byte;swap:boolean);
    Procedure neg(n:byte);
    Procedure zoom2x;
    Procedure flood(_x,_y:TCoordinate; c1:byte);
    Procedure flashLine; virtual;
    {$IFDEF fw}
    Procedure fw(_x,_y:TCoordinate;s:string;color,f:byte);
    {$ENDIF}
    Destructor done; virtual;
  end;  {TBuf2d}

Constructor TBuf2d.init0;
begin
  x:=0; y:=0;
  w:=0; h:=0;
  d:=nil;
  method:=mtMovsd;
end;  {TBuf2d.init0}

Constructor TBuf2d.init(_x,_y,_w,_h:TCoordinate);
begin
  inherited init(_x,_y,_w,_h);
  dim;
  method:=mtMovsd;
end;  {TBuf2d.init}

Procedure TBuf2d.clear;
begin
  inherited clear;
  d:=nil;
end;  {TBuf2d.clear}

Procedure TBuf2d.free;
begin
  if not empty then freemem(d,contentSize);
  clear;
end;  {TBuf2d.free}

Procedure TBuf2d.dim;
begin
  if (w=0) or (h=0) then begin
    clear;
    exit;
  end;
  getmem(d,contentSize);
  if d=nil then clear else paint(0);
end;  {TBuf2d.dim}

Procedure TBuf2d.redim;
var _w,_h:TCoordinate;
begin
  _w:=w;
  _h:=h;
  free;
  init(x,y,_w,_h);
end;  {TBuf2d.redim}

Procedure TBuf2d.copyToMe(src:PRect);
begin
  free;
  if src=nil then exit;
  init(src^.x,src^.y,src^.w,src^.h);
  if typeof(src^)=typeof(TBuf2d) then
    if not PBuf2d(src)^.empty then move(PBuf2d(src)^.d^,d^,w*h);
end;  {TBuf2d.copyToMe}

Procedure TBuf2d.resize(_w,_h:TCoordinate);
var
  _d:pointer;
  j:longint;
begin
  if (_w=0) or (_h=0) then begin free; exit; end;
  getmem(_d,_w*_h);
  if _d=nil then die(errGetmem) else fillchar(_d^,_w*_h,0);
  if d<>nil then
    for j:=0 to Min(h,_h)-1 do
      move(atline(j)^,ptr(ofs(_d^)+j*_w)^,Min(w,_w));
  free;
  d:=_d;
  w:=_w;
  h:=_h;
end;  {TBuf2d.resize}

Procedure TBuf2d.paint(color:byte);
begin
  if not empty then fillchar(d^,contentSize,color);
end;  {TBuf2d.paint}

Function  TBuf2d.load(var f:TStream):boolean;
begin
  free;
  result:=true;
  f.readOrSkip(w,sizeof(w),result);
  f.readOrSkip(h,sizeof(h),result);
  dim;
  if not empty then result:=f.read(d^,contentSize) and result;
end;  {TBuf2d.load}

Function  TBuf2d.save(var f:TStream):boolean;
begin
  result:=true;
  f.writeOrSkip(w,sizeof(w),result);
  f.writeOrSkip(h,sizeof(h),result);
  if not empty then result:=f.write(d^,contentSize) and result;
end;  {TBuf2d.save}

Function  TBuf2d.empty:boolean;
begin
  if inherited empty then d:=nil;
  result:=(d=nil);
end;  {TBuf2d.empty}

Function  TBuf2d.contains(_x,_y:longint):boolean;
begin
  result:=inherited contains(_x,_y) and not empty;
end;  {TBuf2d.contains}

Function  TBuf2d.at(_x,_y:TCoordinate):pointer;
begin
  result:=nil;
  if empty or (_x<0) or (_x>=w) or (_y<0) or (_y>=h) then exit;
  result:=d;
  inc(result,_y*w+_x);
end;  {TBuf2d.at}

Function  TBuf2d.atLine(_y:TCoordinate):pointer;
begin
  if empty or (_y<0) or (_y>=h) then result:=nil
  else begin
    result:=d;
    inc(result,_y*w);
  end;
end;  {TBuf2d.atline}

Function  TBuf2d.getPoint(_x,_y:TCoordinate):byte;
var where:pointer;
begin
  where:=at(_x,_y);
  if where=nil then result:=OUT_OF_BUF2D else result:=byte(where^);
end;  {TBuf2d.getpoint}

Procedure TBuf2d.setPoint(_x,_y:TCoordinate; point:byte);
var where:pointer;
begin
  where:=at(_x,_y);
  if where<>nil then byte(where^):=point;
end;  {TBuf2d.setpoint}

Procedure TBuf2d.xorPoint(_x,_y:TCoordinate; point:byte);
var where:pointer;
begin
  where:=at(_x,_y);
  if where<>nil then byte(where^):=byte(where^) xor point;
end;  {TBuf2d.xorpoint}

Procedure TBuf2d.addPoint(_x,_y:TCoordinate; point:byte);
var where:pointer;
begin
  where:=at(_x,_y);
  if where<>nil then byte(where^):=byte(byte(where^)+point);
end;  {TBuf2d.addpoint}

Procedure TBuf2d.paintRow(_x,_y,_w:TCoordinate; c:byte);
var p:pointer;
begin
  if empty then exit;
  if (_y<0) or (_y>=h) or (_w<=0) or (_x+_w<=0) or (_x>=w) then exit;
  if _x<0 then begin
    inc(_w,_x);
    _x:=0;
  end;
  if _x+_w>w then _w:=w-_x;
  p:=at(_x,_y);
  if p<>nil then fillchar(p^,_w,c);
end;  {TBuf2d.paintRow}

Procedure TBuf2d.paintColumn(_x,_y,_h:TCoordinate; c:byte);
var
  p:pointer;
  j:integer;
begin
  if empty then exit;
  if (_x<0) or (_x>w) or (_h<=0) or (_y+_h<=0) or (_y>=h) then exit;
  if _y<0 then begin
    inc(_h,_y);
    _y:=0;
  end;
  if _y+_h>h then _h:=h-_y;
  p:=at(_x,_y);
  if p<>nil then
    for j:=0 to pred(_h) do begin
      byte(p^):=c;
      inc(p,w);
    end;
end;  {TBuf2d.paintColumn}

Procedure TBuf2d.quad(_x,_y,_w,_h:TCoordinate; c:byte);
var j:longint;
begin
  if empty then exit;
  if (_w<=0) or (_h<=0) or (_x+_w<=0) or (_y+_h<=0) or (_x>=w) or (_y>=h) then exit;
  for j:=Max(_y,0) to _y+pred(Min(h,_h)) do
    paintRow(_x,j,_w,c);
end;  {TBuf2d.quad}

Procedure TBuf2d.quad_(_x,_y,_w,_h:TCoordinate; c:byte);
begin
  paintRow(_x,_y,_w,c);
  paintRow(_x,pred(_y+_h),_w,c);
  paintColumn(_x,succ(_y),pred(pred(_h)),c);
  paintColumn(pred(_x+_w),succ(_y),pred(pred(_h)),c);
end;  {TBuf2d.quad_}

Procedure TBuf2d.border(thickness,c1,c2:byte);
var i:integer;
begin
  if empty or (thickness=0) then exit;
  i:=h; if w<h then i:=w;
  if thickness>i shr 1 then thickness:=i shr 1;
  quad(0,0,w,thickness,c1);
  quad(w-thickness,0,thickness,h,c2);
  quad(0,h-thickness,w,thickness,c2);
  quad(0,0,thickness,h,c1);
  if c1=c2 then exit;
  for i:=0 to thickness-1 do begin
    paintRow(i,pred(h)-i,thickness-i,c2);
    paintRow(w-thickness,i,thickness-i,c1);
  end;
end;  {TBuf2d.border}

procedure TBuf2d.line(x0,y0,x1,y1:TCoordinate; c:byte); {just the basic routine - no clipping}
var p,dx,dy,iy,ry,acc:TCoordinate;
begin
  if x1<x0 then begin
    dx:=x0; x0:=x1; x1:=dx;
    dy:=y0; y0:=y1; y1:=dy;
  end;
  if (x1<0) or (x0>=w) then exit;
  p:=y0*w+x0;
  dx:=y0; dy:=y1; if y1<y0 then begin dx:=y1; dy:=y0; end;
  if (dy<0) or (dx>=h) then exit;
  dx:=x1-x0; dy:=abs(y1-y0);
  iy:=1; ry:=w;
  if y1<y0 then begin iy:=-iy; ry:=-ry; end;
  acc:=dy; if dx>dy then acc:=dx; acc:=acc shr 1;
  if dx>dy then
    repeat
      if (x0>=0) and (x0<w) and (y0>=0) and (y0<h) then mem[ofs(d^)+p]:=c;
      if x0=x1 then break;
      inc(acc,dy);
      if acc>=dx then begin
        dec(acc,dx);
        inc(y0,iy);
        inc(p,ry);
      end;
      inc(x0); inc(p);
    until false
  else
    repeat
      if (x0>=0) and (x0<w) and (y0>=0) and (y0<h) then mem[ofs(d^)+p]:=c;
      if y0=y1 then break;
      inc(acc,dx);
      if acc>=dy then begin
        dec(acc,dy);
        inc(x0);
        inc(p);
      end;
      inc(y0,iy); inc(p,ry);
    until false;
end;  {TBuf2d.line}

Procedure TBuf2d.turnRight;
var
  _l,_r,_d:pointer;
  i,_w,_h:dword;
begin
  if empty then exit;
  getmem(_d,contentSize);
  _r:=_d;
  _w:=w; _h:=h;
  for i:=0 to pred(w) do begin
    _l:=at(i,pred(h));
    asm
      mov  esi,_l
      mov  edi,_r
      mov  ecx,_h
    @1:
      mov  al,[edi]
      mov  ah,[esi]
      mov  [esi],al
      mov  [edi],ah
      inc  edi
      sub  esi,_w
      dec  ecx
      jnz  @1
    end;
    inc(_r,h);
  end;
  freemem(d,contentSize);
  d:=_d;
  w:=_h; h:=_w;
end;  {TBuf2d.turnRight}

Procedure TBuf2d.flipH;
var i,j:longint;
begin
  if empty then exit;
  for j:=pred(h) downto 0 do
    for i:=pred(w shr 1) downto 0 do
      xchg(byte(at(i,j)^),byte(at(w-1-i,j)^),1);
end;  {TBuf2d.flipH}

Procedure TBuf2d.flipV;
var i,j:longint;
begin
  if empty then exit;
  for j:=pred(h shr 1) downto 0 do
    xchg(byte(atline(j)^),byte(atline(h-1-j)^),w);
end;  {TBuf2d.flipV}

Procedure TBuf2d.pasteInMe(_x,_y:TCoordinate;host:PBuf2d);
var
  c:TRect;
  _d,_s:pointer;
begin
  if (host=nil) then exit;
  if empty or host^.empty or (_x>=w) or (_y>=h) or (_x+host^.w<=0) or (_y+host^.h<=0) or (host^.method=mtNone) or (host^.method=0) then exit;
  c.init(0,0,host^.w,host^.h);
  {$IFDEF clip}
  if clipping then c.intersect(clip);
  {$ENDIF}
  if _x<0 then begin inc(c.w,_x); c.x:=-_x; _x:=0; end;
  if _y<0 then begin inc(c.h,_y); c.y:=-_y; _y:=0; end;
  if c.empty then exit;
  if _x+c.w>w then c.w:=w-_x;
  if _y+c.h>h then c.h:=h-_y;
  _s:=host^.at(c.x,c.y);
  _d:=at(_x,_y);
  while c.h>0 do begin
    pasteLine(_s,_d,c.w,host^.method);
    inc(_s,host^.w);
    inc(_d,w);
    dec(c.h);
  end;
end;  {TBuf2d.pasteInMe}

Procedure TBuf2d.pasteMeTo(dest:PBuf2d;_x,_y:TCoordinate);
var
  c:TRect;
  _d,_s:pointer;
begin
  if (dest=nil) or (method=mtNone) or (method=0) then exit;
  if empty or dest^.empty or (_x+w<=0) or (_y+h<=0) or (_x>=dest^.w) or (_y>=dest^.h) then exit;
  c.init(0,0,w,h);
  {$IFDEF clip}
  if clipping then c.intersect(clip);
  {$ENDIF}
  if _x<0 then begin inc(c.w,_x); c.x:=-_x; _x:=0; end;
  if _y<0 then begin inc(c.h,_y); c.y:=-_y; _y:=0; end;
  if _x+w>dest^.w then c.w:=dest^.w-_x;
  if _y+h>dest^.h then c.h:=dest^.h-_y;
  _s:=at(c.x,c.y);
  _d:=dest^.at(_x,_y);
  while c.h>0 do begin
    pasteLine(_s,_d,c.w,method);
    inc(_s,w);
    inc(_d,dest^.w);
    dec(c.h);
  end;
end;  {TBuf2d.pasteMeTo}

Procedure TBuf2d.cloneFrom(p:PBuf2d);
begin
  x:=p^.x; y:=p^.y;
  resize(p^.w,p^.h);
  move(p^.d^,d^,ContentSize);
end;  {TBuf2d.cloneFrom}

Procedure TBuf2d.cycleH(rel:longint);
const CYCLEMAXWIDTH=1024;
var
  j,w_rel:longint;
  backup:array[0..CYCLEMAXWIDTH-1] of byte;
begin
  if (w<=1) or empty then exit;
  if abs(rel)>=w then rel:=rel mod w;
  if rel>0 then rel:=w-rel else rel:=-rel;
  if rel>=CYCLEMAXWIDTH then die(errCycleH);
  if rel=0 then exit;
  w_rel:=w-rel;
  for j:=pred(h) downto 0 do begin
    move(atline(j)^,backup,rel);
    move(at(rel,j)^,atline(j)^,w_rel);
    move(backup,at(w_rel,j)^,rel);
  end;
end;  {TBuf2d.cycleH}

Procedure TBuf2d.cycleV(rel:longint);
var backup:pointer;
begin
  if (h<=1) or empty then exit;
  if abs(rel)>=h then rel:=rel mod h;
  if rel>0 then rel:=h-rel else rel:=-rel;
  if rel=0 then exit;
  getmem(backup,rel*w);
  move(d^,backup^,rel*w);
  move(atline(rel)^,d^,(h-rel)*w);
  move(backup^,atline(h-rel)^,rel*w);
  freemem(backup,rel*w);
end;  {TBuf2d.cycleV}

Procedure TBuf2d.shiftH(rel:longint);
var j:longint;
begin
  if empty or (rel=0) then exit;
  if abs(rel)>=w then paint(0)
  else if rel<0 then begin
    rel:=-rel;
    for j:=pred(h) downto 0 do begin
      move(at(rel,j)^,atline(j)^,w-rel);
      fillchar(at(w-rel,j)^,rel,0);
    end;
  end else
    for j:=pred(h) downto 0 do begin
      move(atline(j)^,at(rel,j)^,w-rel);
      fillchar(atline(j)^,rel,0);
    end;
end;  {TBuf2d.shiftH}

Procedure TBuf2d.shiftV(rel:longint);
begin
  if empty or (rel=0) then exit;
  if abs(rel)>=w then paint(0)
  else if rel<0 then begin
    rel:=-rel;
    move(atline(rel)^,d^,(h-rel)*w);
    fillchar(atline(h-rel)^,rel*w,0);
  end else begin
    rotmove(d^,atline(rel)^,(h-rel)*w);
    fillchar(d^,rel*w,0);
  end;
end;  {TBuf2d.shiftV}

Procedure TBuf2d.replacePoint(old,new:byte;swap:boolean);
var i,j:integer;
begin
  if empty then exit;
  for j:=h-1 downto 0 do
    for i:=w-1 downto 0 do
      if getpoint(i,j)=old then
        setpoint(i,j,new)
      else if swap and (getpoint(i,j)=new) then
         setpoint(i,j,old);
end;  {TBuf2d.replacePoint}

Procedure TBuf2d.neg(n:byte);
var i,j:integer;
begin
  if empty then exit;
  for j:=0 to h-1 do
    for i:=0 to w-1 do
      setpoint(i,j,n-getpoint(i,j));
end;  {TBuf2d.neg}

Procedure TBuf2d.zoom2x; {does not work for the last odd line and row}
var
  j,_w:longint;
  _s,_d:pointer;
begin
  if empty then exit;
  _w:=w div 2;
  for j:=pred(h div 2) downto 0 do begin
    _s:=d; inc(_s,j*w+w div 2);
    _d:=d; inc(_d,2*j*w+w-w and 1);
    asm
      mov  esi,_s
      mov  edi,_d
      mov  ecx,_w
    @1:
      dec  esi
      mov  eax,[esi]
      mov  ah,al
      dec  edi
      dec  edi
      mov  [edi],ax
      dec  ecx
      jnz  @1
    end;
    pasteLine(atline(j*2),atline(j*2+1),w,mtMovsd);
  end;
end;  {TBuf2d.zoom2x}

Procedure TBuf2d.flood2(_x,_y:TCoordinate; c1:byte);
const
  RUNNING_UP   =$80;
  RUNNING_LEFT =$40;
  SEARCH_UP    =1;
  SEARCH_DOWN  =2;
var
  i,j:TCoordinate;
  c0,flags:byte;

  procedure floodPush(x_,y_:TCoordinate);
  begin
    if floodfillSP<FLOODFILLSTACKSIZE then begin
      floodfillstack[floodfillSP].x:=x_;
      floodfillstack[floodfillSP].y:=y_;
      inc(floodfillSP);
    end;
  end;  {floodPush}

begin {TBuf2d.flood2}
  if not contains(_x,_y) then exit;
  c0:=getPoint(_x,_y); if c0=c1 then exit;
  j:=_y; flags:=0;
  repeat
    if (getPoint(_x,j)<>c0) or (j<0) or (j>=h) then begin
      if flags and RUNNING_UP=0 then begin
        j:=pred(_y);
        flags:=flags or RUNNING_UP;
      end else break;
    end;
    if (getPoint(_x,j)<>c0) and (flags and RUNNING_UP<>0) then break;
    flags:=flags and not($43);
    i:=_x;
    repeat
      if (getPoint(i,j)<>c0) or (i<0) or (i>=w) then begin
        if flags and RUNNING_LEFT=0 then begin
          i:=pred(_x);
          flags:=flags or RUNNING_LEFT;
        end else break;
      end;
      if (getPoint(i,j)<>c0) and (flags and RUNNING_LEFT<>0) then break;
      setPoint(i,j,c1);
      if getPoint(i,j-1)<>c0 then
        flags:=flags or SEARCH_UP
      else if flags and SEARCH_UP<>0 then begin
        floodPush(i,j-1);
        flags:=flags and not(SEARCH_UP);
      end;
      if getPoint(i,j+1)<>c0 then
        flags:=flags or SEARCH_DOWN
      else if flags and SEARCH_DOWN<>0 then begin
        floodPush(i,j+1);
        flags:=flags and not(SEARCH_DOWN);
      end;
      if flags and RUNNING_LEFT=0 then inc(i) else dec(i);
    until false;
    if flags and RUNNING_UP=0 then inc(j) else dec(j);
  until j<0;
end;  {TBuf2d.flood2}

procedure TBuf2d.flood(_x,_y:TCoordinate; c1:byte);
begin
  floodfillSP:=0;
  flood2(_x,_y,c1);
  while floodfillSP>0 do begin
    dec(floodfillSP);
    flood2(floodfillstack[floodfillSP].x,floodfillstack[floodfillSP].y,c1);
  end;
end;

Procedure TBuf2d.flashline;
begin
  RunError(errAbstractMethod);
end;  {TBuf2d.flashline}

{$IFDEF fw}
procedure TBuf2d.fw(_x,_y:TCoordinate;s:string;color,f:byte);
var i,j,k:longint;
begin
  if f and $80<>0 then quad(_x,_y,length(s) shl either(f=0,3,2),7,0);
  f:=f and 1;
  for k:=1 to length(s) do
    for j:=0 to 7 do
      for i:=0 to either(f=0,7,3) do
        if font8[f][ord(s[k]) shl 3+j] and ($80 shr i)<>0 then setpoint(_x+pred(k) shl (2+byte(f=0))+i,_y+j,color);
end;  {TBuf2d.fw}
{$ENDIF}

Destructor TBuf2d.done;
begin
  free;
end;  {TBuf2d.done}

{note: TBuf2d has virtual methods and thus must be instantiated properly}
{$ENDIF}