{TMT Pascal version}
{$IFNDEF syst}
{$DEFINE syst}
type
  string8 =string[8];
  string11=string[11];
  string20=string[20];
  string80=string[80];
const
  ROM_TICKS    =$046C;
  ROM_KEYFLAGS =$0417;
  ROM_KEYSTATE =$0418;
  FLAGS_CARRY  =1 shl 0;
  FLAGS_ZERO   =1 shl 6;
  BUFSIZE      =4096;
  faREADONLY   =$01;
  faHIDDEN     =$02;
  faSYSTEM     =$04;
  faVOLUMEID   =$08;
  faDIRECTORY  =$10;
  faARCHIVE    =$20;
  faANYFILE    =faREADONLY or faHIDDEN or faSYSTEM or faVOLUMEID or faDIRECTORY or faARCHIVE;
  kfRIGHTSHIFT =1 shl 0;
  kfLEFTSHIFT  =1 shl 1;
  kfCTRL       =1 shl 2;
  kfALT        =1 shl 3;
  kfSCROLLLOCK =1 shl 4;
  kfNUMLOCK    =1 shl 5;
  kfCAPSLOCK   =1 shl 6;
  kfINSERT     =1 shl 7;
  kfLEFTCTRL   =1 shl 0;
  kfLEFTALT    =1 shl 1;
  kfSYSREQ     =1 shl 2;
  kfPAUSE      =1 shl 3;
  kfSCROLLHIT  =1 shl 4;
  kfNUMHIT     =1 shl 5;
  kfCAPSHIT    =1 shl 6;
  kfINSERTHIT  =1 shl 7;
  kfANYSHIFT   =kfRIGHTSHIFT or kfLEFTSHIFT;
  kfANYCTRL    =kfCTRL or kfLEFTCTRL;
  kfANYALT     =kfALT or kfLEFTALT;
  CR           =#13;
  LF           =#10;
  CRLF         =CR+LF;
  svga         :boolean=false;
  {$IFDEF useGFX}actGFX:boolean=false;{$ENDIF}
  {$IFDEF useUSS}actUSS:boolean=false;{$ENDIF}
  {$IFDEF usePCK}actPCK:boolean=false;{$ENDIF}
  {Error Codes}
  errOk                  =0;
  errVGANotSupported     =20;
  errVGAModeSet          =21;
  errVBENotDetected      =22;
  errVBE20Needed         =23;
  errVBECardMemory       =24;
  errVBEModeNotSupported =25;
  errVBEModeSet          =26;
  errUSSLoad             =30;
  errUSSInit             =31;
  errGIFImageOk          =0;
  errGIFBadFile          =41;
  errGIFBadGIFCode       =42;
  errGIFNotAGIFFile      =43;
  errGIFInvalidBlockSize =44;
  errGIFBadSymbolSize    =45;
  errGIFBadFirstGIFCode  =46;
  errGIFBadSeek          =47;
  errGIFBufferError      =48;
  errGIFImageTooBig      =49;
  errGIFUnknownError     =99;
  errPCKOpen             =60;
  errPCKLoad             =61;
  errPCKSeek             =62;
  errDPMI800             =50;
  errGetmem              =51;
  errBMFLoad             =52;
  errCycleH              =53;
  errModeByRes           =54;
  errParamsNeeded        =55;
  errFileNotExists       =56;
  errUnknownFormat       =57;
  errUnexpectedEOF       =58;
  errAbstractMethod      =211;
  errUserBreak           =255;
  WORDBREAKERS:set of char=[LF,CR,' ','$','%','&','(',')','*','+',',','-','.','/',':',';','<','=','>','[','\',']','{','|','}','~'];
  onoff:array[boolean] of string[3]=('Off','On');
{$IFNDEF __TMT__}
type smallint=integer;
{$ENDIF}

{$IFDEF useUSS}procedure CloseUSS; forward;{$ENDIF}
{$IFDEF usePCK}procedure ClosePCK; forward;{$ENDIF}
{$IFDEF useGFX}procedure CloseGFX; forward;{$ENDIF}
{$IFDEF usershutdown}procedure UserShutdown; forward;{$ENDIF}

procedure SetText;
var r:TRmRegs;
begin
  ClearRmRegs(r);
  with r do begin
    AX:=$1202;
    BL:=$30;
  end;
  RealModeInt($10,r);
  ClearRmRegs(r);
  r.AL:=$3;
  RealModeInt($10,r);
  ClearRmRegs(r);
  r.AX:=$1112;
  RealModeInt($10,r);
end;  {SetText}

function  keyPressed:boolean;
var r:TRmRegs;
begin
  ClearRmRegs(r);
  r.AH:=$0B;
  RealModeInt($21,r);
end;  {keyPressed}

function  readKey:char;
var r:TRmRegs;
begin
  ClearRmRegs(r);
  r.AH:=8;
  RealModeInt($21,r);
  result:=chr(r.AL);
end;  {readKey}

FUNCTION  hiWord(n:dword):word; assembler;
asm
  mov  eax,n
  shr  eax,16
end;  {hiWord}

FUNCTION  minW(x,y:word):word;assembler;
asm
  mov  bx,y
  mov  ax,x
  cmp  ax,bx
  jbe  @end
  xchg ax,bx
@end:
end;  {minW}

FUNCTION  maxW(x,y:word):word;assembler;
asm
  mov  bx,y
  mov  ax,x
  cmp  ax,bx
  jae  @end
  xchg ax,bx
@end:
end;  {maxW}

FUNCTION  minI(x,y:smallint):integer;assembler;
asm
  mov  bx,y
  mov  ax,x
  cmp  ax,bx
  jle  @end
  xchg ax,bx
@end:
end;  {minI}

FUNCTION  maxI(x,y:smallint):integer;assembler;
asm
  mov  bx,y
  mov  ax,x
  cmp  ax,bx
  jge  @end
  xchg ax,bx
@end:
end;  {maxI}

FUNCTION  minD(x,y:dword):longint;assembler;
asm
  mov  ebx,y
  mov  eax,x
  cmp  eax,ebx
  jbe  @end
  xchg eax,ebx
@end:
end;  {minD}

FUNCTION  maxD(x,y:dword):longint;assembler;
asm
  mov  ebx,y
  mov  eax,x
  cmp  eax,ebx
  jae  @end
  xchg eax,ebx
@end:
end;  {maxD}

FUNCTION  min(x,y:longint):longint;assembler;
asm
  mov  ebx,y
  mov  eax,x
  cmp  eax,ebx
  jle  @end
  xchg eax,ebx
@end:
end;  {min}

FUNCTION  max(x,y:longint):longint;assembler;
asm
  mov  ebx,y
  mov  eax,x
  cmp  eax,ebx
  jge  @end
  xchg eax,ebx
@end:
end;  {max}

FUNCTION  bi2By(w:word):word;inline($58/5/7/0/$c1/$e8/3);

FUNCTION  isIn(n,min,max:longint):boolean; assembler;
asm
  xor  edx,edx
  mov  eax,n
  cmp  eax,min
  jl   @false
  cmp  eax,max
  jg   @false
  inc  edx
@false:
  xchg eax,edx
end;  {isIn}

FUNCTION  bounded(n,min,max:longint):longint; assembler;
asm
  mov  eax,n
  cmp  eax,min
  jge  @1
  mov  eax,min
@1:
  cmp  eax,max
  jle  @2
  mov  eax,max
@2:
end;  {bounded}

FUNCTION  wrapped(n,min,max:longint):longint;
begin
 n:=(n-min) mod (max-min+1);
 if n<0 then wrapped:=n+max+1 else wrapped:=n+min;
end;  {wrapped}

FUNCTION  either(cond:boolean; res1,res2:longint):longint; assembler;
asm
  mov  al,cond
  cmp  al,false
  je   @res2
  mov  eax,res1
  jmp  @end
@res2:
  mov  eax,res2
@end:
end;  {either}

FUNCTION  eitherS(cond:boolean; const res1,res2:string):string; assembler;
asm
  mov  esi,res2
  mov  al,cond
  cmp  al,false
  je   @res2
  mov  esi,res1
@res2:
  mov  edi,result
  xor  eax,eax
  lodsb
  stosb
  xchg eax,ecx
  jecxz @end
  rep  movsb
@end:
end;  {eitherS}

FUNCTION  strToInt(st:string11):longint;
var check:word;
begin
  result:=0;
  val(st,result,check);
end;  {strToInt}

FUNCTION  strToIntDefault(st:string11;default:longint):longint;
var l:longint; check:word;
begin
  val(st,l,check);
  if check=0 then result:=l else result:=default;
end;  {strToIntDefault}

FUNCTION  intToStr(num:longint):string11;
begin
  str(num,result);
end;  {intToStr}

FUNCTION  rep(c:char;howmanytimes:byte):string;
begin
  fillchar(result[1],howmanytimes,c);
  result[0]:=char(howmanytimes);
end;  {rep}

FUNCTION  pad(padchar:char;const what:string;len:integer):string;
begin
  result:='';
  if length(what)>len then exit;
  result:=rep(padchar,len-length(what))+what;
end;  {pad}

const PAD0CHAR:char='0';
FUNCTION  pad0(value:longint; digits:byte):string11;
var st:string11;
begin
  result:=Rep(PAD0CHAR,digits);
  if digits=0 then exit;
  str(Abs(value),st);
  if length(st)+byte(value<0)>digits then begin
    result:=Rep('#',digits);
    exit;
  end;
  move(st[1],result[1+digits-length(st)],length(st));
  if value<0 then result[1]:='-';
  if result='-' then result:='#';
end;  {pad0}

FUNCTION  lcased(s:string):string; assembler;
asm
  mov  esi,s
  mov  edi,@result
  xor  ecx,ecx
  mov  cl,[esi]
  movsb
  jecxz @end
@1:
  lodsb
  cmp  al,'A'
  jl   @2
  cmp  al,'Z'
  jg   @2
  add  al,'a'-'A'
@2:
  stosb
  loop @1
@end:
end;  {lcased}

function  hex(n:dword):string8; assembler;
asm
  mov  eax,8
  mov  ecx,n
  mov  edi,result
  stosb
  add  edi,eax
  dec  edi
  xchg eax,ecx
  sti
  std
@1:
  push ax
  and  al,0Fh
  cmp  al,9
  jbe  @2
  add  al,'A'-'9'-1
@2:
  add  al,'0'
  stosb
  pop  ax
  shr  eax,4
  loop @1
  cli
  cld
end;  {hex}

procedure chgB(where:pointer; c1,c2:byte; size:dword); assembler;
asm
  mov  ecx,size
  jecxz @end
  mov  edi,where
  or   edi,edi
  jz   @end
  mov  al,c1
  mov  ah,c2
@1:
  repne scasb
  jecxz @end
  mov  es:[edi],ah
  jmp  @1
@end:
end;  {chgB}

procedure chgTo(src,dest:pointer; c1,c2:byte; size:dword); assembler; {vsechny c1 v src zapise jako c2 do dest}
asm
  mov  ecx,src
  jecxz @end
  mov  edi,ecx
  mov  ecx,size
  jecxz @end
  mov  esi,dest
  add  esi,ecx
  dec  esi
  mov  ebx,esi
  mov  al,c1
  mov  ah,c2
@1:
  repne scasb
  jne  @end
  mov  esi,ebx
  sub  esi,ecx
  mov  [esi],ah
  jecxz @end
  jmp  @1
@end:
end;  {chgTo}

PROCEDURE xchg(var a,b;bytes:dword); assembler;
asm
 mov  ecx,bytes
 jcxz @2
 mov  esi,a
 mov  edi,b
 mov  eax,esi
 and  eax,edi
 or   eax,eax
 jz   @2
@1:
 mov  al,[edi]
 xchg al,[esi]
 stosb
 lodsb
 loop @1
@2:
end;  {xchg}

procedure rotmove(var src,dest;bytes:dword); assembler; {rotuje data v ramci radku}
asm
  mov  ecx,bytes
  jecxz @end
  mov  esi,src
  mov  edi,dest
  add  esi,ecx
  add  edi,ecx
  mov  edx,4
  shr  ecx,1
  rcl  ebx,1
  shr  ecx,1
  rcl  ebx,1
  jecxz @1_
@1:
  sub  esi,edx
  mov  eax,[esi]
  sub  edi,edx
  mov  [edi],eax
  loop @1
@1_:
  shr  ebx,1
  rcl  ecx,1
  jecxz @2_
  mov  edx,0FFFFh
@2:
  not  edx
  dec  esi
  dec  esi
  mov  eax,[esi]
  and  eax,edx
  dec  edi
  dec  edi
  not  edx
  and  [edi],edx
  or   [edi],eax
  loop @2
@2_:
  or   ebx,ebx
  jns  @end
  dec  esi
  dec  edi
  xchg edi,esi
  movsb
@end:
end;  {rotmove}

procedure clearRegs; inline($66/$33/$C0/$66/$33/$DB/$66/$33/$C9/$66/$33/$E2/$66/$33/$F6/$66/$33/$FF);

procedure fillword(var where; words:dword; value:word); assembler;
asm
  mov  edi,where
  mov  ax,value
  mov  ecx,eax
  rol  eax,16
  mov  ax,cx
  mov  ecx,words
  shr  ecx,1
  rep  stosd
  adc  ecx,0
  rep  stosw
end;   {fillword}

procedure fillattr(var where; count:dword; attr:byte); assembler;
asm
  mov  edi,where
  mov  al,attr
  mov  ecx,count
  jecxz @end
@attr:
  stosb
  inc  edi
  loop @attr
@end:
end;   {fillword}

function  trim(s:string):string;
begin
  while (length(s)>0) and (s[1] in [' ',#0]) do delete(s,1,1);
  while (length(s)>0) and (s[length(s)] in [' ',#0]) do dec(s[0]);
  result:=s;
end;  {trim}

procedure biosWriteChar(c:char);
var r:TRmRegs;
begin
  ClearRmRegs(r);
  with r do begin
    AH:=2;
    DL:=ord(c);
  end;
  RealModeInt($21,r);
end;  {biosWriteChar}

procedure biosWrite(const st:string);
var i:dword;
begin
  for i:=1 to length(st) do
    biosWriteChar(st[i]);
end;  {biosWrite}

procedure biosWriteLn(const st:string);
begin
  biosWrite(st+CRLF);
end;  {biosWriteLn}

function  fileExists(const filename:string):boolean;
var
  r:TRmRegs;
  filenameseg:word;
  dtaseg:word;
begin
  result:=false;
  if filename='' then exit;
  filenameseg:=DOSMemoryAlloc(256);
  if filenameseg=0 then exit;
  dtaseg:=DOSMemoryAlloc(64);
  if dtaseg=0 then begin
    DOSMemoryFree(filenameseg);
    exit;
  end;
  move(filename[1],pointer(dword(filenameseg) shl 4)^,length(filename));
  mem[dword(filenameseg) shl 4+length(filename)]:=0;
  ClearRmRegs(r);
  with r do begin
    AH:=$1A;
    DS:=dtaseg; {DX already 0}
    RealModeInt($21,r); {sets disk transfer address}
    AH:=$4E;
    DS:=filenameseg;
    DX:=0;
    CX:=faANYFILE and not(faVOLUMEID or faDIRECTORY);
    RealModeInt($21,r); {find first}
    result:=Flags and FLAGS_CARRY=0;
  end;
  DOSMemoryFree(dtaseg);
  DOSMemoryFree(filenameseg);
end;  {fileExists}

procedure insertFileBytes(var f:file;wherefrom,howmany:longint);
var
  pos1,pos2,origsize:longint;
  m:word;
  buffer:array[0..BUFSIZE-1] of byte;
begin
  origsize:=filesize(f);
  if (wherefrom>origsize) or (howmany<=0) {or (TFileRec(f).mode<>fmInOut)} then exit;
  pos1:=origsize; pos2:=origsize+howmany;
  repeat
    dec(pos1,BUFSIZE); dec(pos2,BUFSIZE);
    if pos1<wherefrom then break;
    seek(f,pos1); blockread(f,buffer,BUFSIZE);
    seek(f,pos2); blockwrite(f,buffer,BUFSIZE);
  until FALSE;
  m:=(filesize(f)-wherefrom-howmany) mod BUFSIZE;
  if m<>0 then begin
    seek(f,wherefrom);         blockread(f,buffer,m);
    seek(f,wherefrom+howmany); blockwrite(f,buffer,m);
  end;
end;  {insertFileBytes}

procedure deleteFileBytes(var f:file;wherefrom,howmany:longint);
var
  j:longint;
  m:word;
  buffer:array[0..BUFSIZE-1] of byte;
begin
  if (wherefrom>=filesize(f)) or (howmany<=0) {or (FileRec(f).mode<>fmInOut)} then exit;
  if wherefrom+howmany>filesize(f) then howmany:=filesize(f)-wherefrom;
  j:=-1;
  for j:=0 to (filesize(f)-wherefrom-howmany) div BUFSIZE-1 do begin
    seek(f,wherefrom+j*BUFSIZE+howmany); blockread(f,buffer,BUFSIZE);
    seek(f,wherefrom+j*BUFSIZE); blockwrite(f,buffer,BUFSIZE);
  end;
  inc(j);
  m:=(filesize(f)-wherefrom-howmany) mod BUFSIZE;
  if m<>0 then begin
    seek(f,wherefrom+j*BUFSIZE+howmany); blockread(f,buffer,m);
    seek(f,wherefrom+j*BUFSIZE); blockwrite(f,buffer,m);
  end;
  seek(f,filesize(f)-howmany); truncate(f);
end;  {deleteFileBytes}

function  timestr:string8;
var r:TRmRegs;
begin
  ClearRmRegs(r);
  r.ah:=$2C;
  RealModeInt($21,r);
  with r do result:=chr(48+ch div 10)+chr(48+ch mod 10)+chr(32+26*byte(dl>49))+chr(48+cl div 10)+chr(48+cl mod 10);
end;  {timestr}

function  datestr:string8;
var r:TRmRegs;
begin
  ClearRmRegs(r);
  r.ah:=$2A;
  RealModeInt($21,r);
  with r do result:=chr(48+dl div 10 mod 10)+chr(48+dl mod 10)+'.'+chr(48+dh div 10 mod 10)+chr(48+dh mod 10)+'.'+chr(48+cx div 10 mod 10)+chr(48+cx mod 10);
end;  {datestr}

function  unix_timestamp:dword;
const days:array[1..12] of word=(0,31,59,90,120,151,181,212,243,273,304,334);
var r:TRmRegs;
begin
  ClearRmRegs(r);
  r.ah:=$2A;
  RealModeInt($21,r);
  with r do result:=946681200 + (cx-2000)*365 + (pred(cx-2000) div 4) + days[dh] + pred(dl) + either((dh>2) and ((cx and 3) = 0), 1, 0);
  r.ah:=$2C;
  RealModeInt($21,r);
  with r do result:=result*86400 + ch*3600 + cl*60 + dh;
end;

function  cutword(var s:string):string; {odrizne ze stringu slovo a vrati jej}
var i,p:longint;
begin
  s:=trim(s);
  p:=-1;
  for i:=1 to length(s) do begin
    if s[i] in WORDBREAKERS then begin
      p:=i;
      break;
    end;
    if p<>-1 then break;
  end;
  if p=-1 then begin
    result:=s;
    s:='';
  end else begin
    result:=copy(s,1,p-1);
    s:=copy(s,p+byte(p<>$FF),$FF);
  end;
end;  {cutword}

function  cutstr(var s:string;delimiter:char):string;
var p:byte;
begin
  p:=pos(delimiter,s);
  if p=0 then begin
    result:=s;
    s:='';
  end else begin
    result:=copy(s,1,p-1);
    delete(s,1,p);
  end;
end;  {cutstr}

PROCEDURE WaitTicks(n:longint);
begin
  inc(n,memd[ROM_TICKS]);
  repeat
  until (memd[ROM_TICKS]>=n) or (port[$60]=1);
end;  {WaitTicks}

procedure die(haltcode:byte);
var r:TRmRegs;
begin
  bioswriteln(CRLF+'Halting..');
  {$IFDEF useGFX}CloseGFX;{$ENDIF}
  {$IFDEF useUSS}CloseUSS;{$ENDIF}
  {$IFDEF usePCK}ClosePCK;{$ENDIF}
  {$IFDEF usershutdown}UserShutdown;{$ENDIF}
  case haltcode of
  errOk:                  bioswriteln('Good-bye!');
  {$IFDEF useGFX}
  errVGANotSupported:     bioswriteln('VGA error: VGA not supported!');
  errVGAModeSet:          bioswriteln('VGA error: Can''t set desired VGA mode!');
  errVBENotDetected:      bioswriteln('VBE error: VESA BIOS EXTENTION not detected!');
  errVBE20Needed:         bioswriteln('VBE error: VESA 2.0+ needed to use Linear Frame Buffer (LFB)...'+CRLF+'Run UniVBE by SciTech Soft or something similar.');
  errVBECardMemory:       bioswriteln('VBE error: Not enough memory on graphics card :(');
  errVBEModeNotSupported: bioswriteln('VBE error: Desired VBE mode not supported...');
  errVBEModeSet:          bioswriteln('VBE error: Can''t set desired VESA mode.');
  {$ENDIF}
  {$IFDEF useUSS}
  errUSSLoad:             bioswriteln('USS error: Error loading music module!');
  errUSSInit:             bioswriteln('USS error: Error initializing the soundsystem!');
  {$ENDIF}
  errGIFBadFile:          bioswriteln('GIF error: Bad file');
  errGIFBadGIFCode:       bioswriteln('GIF error: Bad GIF code');
  errGIFNotAGIFFile:      bioswriteln('GIF error: Not a GIF file');
  errGIFInvalidBlockSize: bioswriteln('GIF error: Invalid Block Size');
  errGIFBadSymbolSize:    bioswriteln('GIF error: Bad Symbol Size');
  errGIFBadFirstGIFCode:  bioswriteln('GIF error: Bad first GIF code');
  errGIFBadSeek:          bioswriteln('GIF error: Bad file seek');
  errGIFBufferError:      bioswriteln('GIF error: Buffer error');
  errGIFImageTooBig:      bioswriteln('GIF error: Image too big');
  errGIFUnknownError:     bioswriteln('GIF error: Unknown error');
  {$IFDEF usePCK}
  errPCKOpen:             bioswriteln('PCK error: Error opening data file');
  errPCKLoad:             bioswriteln('PCK error: Error loading a subfile');
  errPCKSeek:             bioswriteln('PCK error: File seek error');
  {$ENDIF}
  errDPMI800:             bioswriteln('DPMI error: Can''t map physical memory to linear'+CRLF+'(error execute function 800h DPMI)'+CRLF+'Try to run with QEMM or HIMEM in raw DOS.');
  errGetmem:              bioswriteln('internal error: GetMem');
  errBMFLoad:             bioswriteln('internal error: BMFont.Load');
  errCycleH:              bioswriteln('internal error: TBuf2d.CycleH');
  errModeByRes:           bioswriteln('internal error: modeByRes.CreateDataDescriptor');
  errParamsNeeded:        bioswriteln('general error: Parameters needed');
  errFileNotExists:       bioswriteln('general error: File not exists');
  errUnknownFormat:       bioswriteln('general error: Unknown format');
  errUnexpectedEOF:       bioswriteln('general error: Unexpected end of file');
  errAbstractMethod:      bioswriteln('general error: Abstract method');
  errUserBreak:           bioswriteln('User break');
  else                    bioswriteln('Unknown error ('+hex(haltcode)+'h)');
  end;
  haltcode:=word(haltcode<>0);
  halt(haltcode);
end;  {die}

{$ENDIF}